import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class DetalleEntity extends Equatable {
  final String uuid;
  final int cantidad;
  final int orden;
  final String productoUuid;
  final String dietaUuid;


  DetalleEntity(this.uuid, this.cantidad, this.orden, this.productoUuid,
      this.dietaUuid);

  Map<String, Object> toJson() {
    return {
      'cantidad': this.cantidad,
      'orden': this.orden,
      'productoUuid': this.productoUuid,
      'dietaUuid': this.dietaUuid
    };
  }


  @override
  String toString() {
    return 'DetalleEntity{uuid: $uuid, cantidad: $cantidad, orden: $orden, productoUuid: $productoUuid, dietaUuid: $dietaUuid}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          super == other &&
              other is DetalleEntity &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              cantidad == other.cantidad &&
              orden == other.orden &&
              productoUuid == other.productoUuid &&
              dietaUuid == other.dietaUuid;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      cantidad.hashCode ^
      orden.hashCode ^
      productoUuid.hashCode ^
      dietaUuid.hashCode;

  static DetalleEntity fromJson(Map<String, Object> json) {
    return DetalleEntity(json['uuid'] as String, json['cantidad'] as int,
        json['orden'] as int, json['productoUuid'] as String, json['dietaUuid'] as String);
  }

  static DetalleEntity fromSnapshot(DocumentSnapshot snapshot, String dietaUuid){
    return DetalleEntity(
      snapshot.documentID,
      snapshot.data['cantidad'],
      snapshot.data['orden'],
      snapshot.data['productoUuid'],
      dietaUuid
    );
  }

  Map<String, Object> toDocument(){
    return {
      'cantidad': this.cantidad,
      'orden': this.orden,
      'productoUuid': this.productoUuid
    };
  }

}
