import 'dart:async';

import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import '../firebase_repository.dart';
import 'cargas_repository.dart';
import 'entities/entities.dart';

class FirebaseCargasRepository implements CargaRepository {
  CollectionReference cargasCollection;
  String empresaId;
  String usuarioId;

  FirebaseCargasRepository({@required String empresaId}) {
    this.cargasCollection = Firestore.instance
        .collection('empresas')
        .document(empresaId)
        .collection("cargas");
  }

  @override
  Future<void> addNewCarga(Carga carga) {
    return cargasCollection.add(carga.toEntity().toDocument());
  }

  @override
  Future<void> deleteCarga(Carga carga) async {
    return cargasCollection.document(carga.uuid).delete();
  }

  @override
  Stream<List<Carga>> cargas() {
    return cargasCollection.snapshots().map((snapshot) {
//      return snapshot.documents.map((doc) {
//        if (doc.data['estado'] == "corral" || doc.data['estado'] == "campo")
//          return Carga.fromEntity(CargaEntity.fromSnapshot(doc));
//      }).toList();
      print(snapshot);
      return snapshot.documents
          .map((car) => Carga.fromEntity(CargaEntity.fromSnapshot(car))).toList();
    });
  }

  @override
  Future<void> updateCarga(Carga update) {
    return cargasCollection
        .document(update.uuid)
        .updateData(update.toEntity().toDocument());
  }

}
