import 'package:firebase_repository/src/entities/caravana_entity.dart';
import 'package:meta/meta.dart';

import '../entities/entities.dart';

@immutable
class Caravana {
  final String uuid;
  final String idManejo;
  final String idCuig;
  final String idElec;
  final String tropaUuid;
  final String tropaNombre;
  final String corralUuid;
  final String corralNombre;
  final DateTime fechaAlta;
  final double pesoAlta;
  final DateTime fechaUltPeso;
  final double pesoUlt;
  final bool sexo;
  final int denticion;
  final String estado;
  final int diasEncierre;
  final String empresaUuid;
  final String origen;
  final String propietario;
  final String empresaNombre;
  final String categoriaUuid;
  final String categoriaNombre;
  final int puerta;
  final String tropaOrigen;
  final String corralOrigen;
  final String categoriaAnterior;
  final double gdpv;
  final DateTime fechaUltimoEncierre;

  Caravana({
    this.uuid,
    this.idManejo,
    this.idCuig,
    this.idElec,
    this.tropaUuid,
    this.tropaNombre,
    this.corralUuid,
    this.corralNombre,
    this.fechaAlta,
    this.pesoAlta,
    this.fechaUltPeso,
    this.pesoUlt,
    this.sexo,
    this.denticion,
    this.estado,
    this.diasEncierre,

    this.empresaUuid,
    this.origen,
    this.propietario,
    this.empresaNombre,
    this.categoriaUuid,
    this.categoriaNombre,
    this.puerta = 0,
    this.tropaOrigen,
    this.corralOrigen,
    this.categoriaAnterior,
    this.gdpv,
    this.fechaUltimoEncierre
  });

  Caravana copyWith(
      {String uuid,
        String idManejo,
        String idCuig,
        String idElec,
        String tropaUuid,
        String tropaNombre,
        String corralNombre,
        String corralUuid,
        DateTime fechaAlta,
        double pesoAlta,
        DateTime fechaUltPeso,
        double pesoUlt,
        bool sexo,
        int denticion,
        String estado,
        int diasEncierre,
        String campoUuid,
        String campoNombre,
        String empresaNombre,
        String empresaUuid,
        String origen,
        String propietario,
        int puerta,
        String tropaOrigen,
        String corralOrigen,
        String categoriaAnterior,
        double gdpv,
        DateTime fechaUltimoEncierre
      }) {
    return Caravana(
        uuid: uuid ?? this.uuid,
        idManejo: idManejo ?? this.idManejo,
        idCuig: idCuig ?? this.idCuig,
        idElec: idElec ?? this.idElec,
        tropaUuid: tropaUuid ?? this.tropaUuid,
        tropaNombre: tropaNombre ?? this.tropaNombre,
        corralNombre: corralNombre ?? this.corralNombre,
        corralUuid: corralUuid ?? this.corralUuid,
        categoriaNombre: categoriaNombre ?? this.categoriaNombre,
        categoriaUuid: categoriaUuid ?? this.categoriaUuid,
        denticion: denticion ?? this.denticion,
        diasEncierre: diasEncierre ?? this.diasEncierre,
        empresaNombre: empresaNombre ?? this.empresaNombre,
        empresaUuid: empresaUuid ?? this.empresaUuid,
        estado: estado ?? this.estado,
        fechaAlta: fechaAlta ?? this.fechaAlta,
        fechaUltPeso: fechaUltPeso ?? this.fechaUltPeso,
        origen: origen ?? this.origen,
        propietario: propietario ?? this.propietario,
        pesoAlta: pesoAlta ?? this.pesoAlta,
        pesoUlt: pesoUlt ?? this.pesoUlt,
        puerta: puerta ?? this.puerta,
        tropaOrigen: tropaOrigen ?? this.tropaOrigen,
        corralOrigen: corralOrigen ?? this.corralOrigen,
        categoriaAnterior: categoriaAnterior ?? this.categoriaAnterior,
        sexo: sexo ?? this.sexo,
        gdpv: gdpv ?? this.gdpv,
        fechaUltimoEncierre : fechaUltimoEncierre ?? this.fechaUltimoEncierre
    );
  }


  @override
  String toString() {
    return 'Caravana{uuid: $uuid, idManejo: $idManejo, idCuig: $idCuig, idElec: $idElec, tropaUuid: $tropaUuid, tropaNombre: $tropaNombre, corralUuid: $corralUuid, corralNombre: $corralNombre, fechaAlta: $fechaAlta, pesoAlta: $pesoAlta, fechaUltPeso: $fechaUltPeso, pesoUlt: $pesoUlt, sexo: $sexo, denticion: $denticion, estado: $estado, diasEncierre: $diasEncierre, empresaUuid: $empresaUuid, origen: $origen, propietario: $propietario, empresaNombre: $empresaNombre, categoriaUuid: $categoriaUuid, categoriaNombre: $categoriaNombre, puerta: $puerta, tropaOrigen: $tropaOrigen, corralOrigen: $corralOrigen, categoriaAnterior: $categoriaAnterior, gdpv: $gdpv, fechaUltimoEncierre: $fechaUltimoEncierre}';
  }


  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Caravana &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              idManejo == other.idManejo &&
              idCuig == other.idCuig &&
              idElec == other.idElec &&
              tropaUuid == other.tropaUuid &&
              tropaNombre == other.tropaNombre &&
              corralUuid == other.corralUuid &&
              corralNombre == other.corralNombre &&
              fechaAlta == other.fechaAlta &&
              pesoAlta == other.pesoAlta &&
              fechaUltPeso == other.fechaUltPeso &&
              pesoUlt == other.pesoUlt &&
              sexo == other.sexo &&
              denticion == other.denticion &&
              estado == other.estado &&
              diasEncierre == other.diasEncierre &&
              empresaUuid == other.empresaUuid &&
              origen == other.origen &&
              propietario == other.propietario &&
              empresaNombre == other.empresaNombre &&
              categoriaUuid == other.categoriaUuid &&
              categoriaNombre == other.categoriaNombre &&
              puerta == other.puerta &&
              tropaOrigen == other.tropaOrigen &&
              corralOrigen == other.corralOrigen &&
              categoriaAnterior == other.categoriaAnterior &&
              gdpv == other.gdpv &&
              fechaUltimoEncierre == other.fechaUltimoEncierre;

  @override
  int get hashCode =>
      uuid.hashCode ^
      idManejo.hashCode ^
      idCuig.hashCode ^
      idElec.hashCode ^
      tropaUuid.hashCode ^
      tropaNombre.hashCode ^
      corralUuid.hashCode ^
      corralNombre.hashCode ^
      fechaAlta.hashCode ^
      pesoAlta.hashCode ^
      fechaUltPeso.hashCode ^
      pesoUlt.hashCode ^
      sexo.hashCode ^
      denticion.hashCode ^
      estado.hashCode ^
      diasEncierre.hashCode ^
      empresaUuid.hashCode ^
      origen.hashCode ^
      propietario.hashCode ^
      empresaNombre.hashCode ^
      categoriaUuid.hashCode ^
      categoriaNombre.hashCode ^
      puerta.hashCode ^
      tropaOrigen.hashCode ^
      corralOrigen.hashCode ^
      categoriaAnterior.hashCode ^
      gdpv.hashCode ^
      fechaUltimoEncierre.hashCode;

  CaravanaEntity toEntity() {
    return CaravanaEntity(
        uuid,
        idManejo,
        idCuig,
        idElec,
        tropaUuid,
        tropaNombre,
        corralUuid,
        corralNombre,
        fechaAlta,
        pesoAlta,
        fechaUltPeso,
        pesoUlt,
        sexo,
        denticion,
        estado,
        diasEncierre,
        empresaUuid,
        origen,
        propietario,
        empresaNombre,
        categoriaUuid,
        categoriaNombre,
        puerta,
        tropaOrigen,
        corralOrigen,
        categoriaAnterior,
        gdpv,
        fechaUltimoEncierre
    );
  }

  static Caravana fromEntity(CaravanaEntity entity) {
    return Caravana(
        uuid: entity.uuid,
        idManejo: entity.idManejo,
        idElec: entity.idElec,
        idCuig: entity.idCuig,
        tropaUuid: entity.tropaUuid,
        tropaNombre: entity.tropaNombre,
        corralUuid: entity.corralUuid,
        corralNombre: entity.corralNombre,
        fechaAlta: entity.fechaAlta,
        fechaUltPeso: entity.fechaUltPeso,
        pesoAlta: entity.pesoAlta,
        pesoUlt: entity.pesoUlt,
        sexo: entity.sexo,
        denticion: entity.denticion,
        estado: entity.estado,
        diasEncierre: entity.diasEncierre,
        empresaUuid: entity.empresaUuid,
        empresaNombre: entity.empresaNombre,
        origen: entity.origen,
        propietario: entity.propietario,
        categoriaUuid: entity.categoriaUuid,
        categoriaNombre: entity.categoriaNombre,
        puerta: entity.puerta,
        tropaOrigen: entity.tropaOrigen,
        corralOrigen: entity.corralOrigen,
        categoriaAnterior: entity.categoriaAnterior,
        gdpv: entity.gdpv,
        fechaUltimoEncierre : entity.fechaUltimoEncierre
    );
  }
}
