import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class Detalle{
  final String uuid;
  final int cantidad;
  final int orden;
  final String productoUuid;
  final String dietaUuid;

  Detalle({this.uuid, this.cantidad, this.orden, this.productoUuid, this.dietaUuid});

  Detalle copyWith({String uuid, int cantidad, int orden, String productoUuid, String dietaUuid}){
    return Detalle(
      uuid: uuid ?? this.uuid,
      cantidad: cantidad ?? this.cantidad,
      orden: orden ?? this.orden,
      productoUuid: productoUuid ?? this.productoUuid,
      dietaUuid: dietaUuid ?? this.dietaUuid
    );
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Detalle &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              cantidad == other.cantidad &&
              orden == other.orden &&
              productoUuid == other.productoUuid &&
              dietaUuid == other.dietaUuid;

  @override
  int get hashCode =>
      uuid.hashCode ^
      cantidad.hashCode ^
      orden.hashCode ^
      productoUuid.hashCode ^
      dietaUuid.hashCode;

  @override
  String toString() {
    return 'Detalle{uuid: $uuid, cantidad: $cantidad, orden: $orden, productoUuid: $productoUuid, dieta: $dietaUuid}';
  }

  DetalleEntity toEntity(){
    return DetalleEntity(uuid, cantidad, orden, productoUuid, dietaUuid);
  }

  static Detalle fromEntity(DetalleEntity entity){
    return Detalle(
      uuid: entity.uuid,
      cantidad: entity.cantidad,
      orden: entity.orden,
      productoUuid: entity.productoUuid,
      dietaUuid: entity.dietaUuid
    );
  }

}